// -------------------------------------------------------------------------
#IFGREATEROREQUAL system_version 700 ;

int bottom_line;
#define calculator_line_size 50

scroll_up()
{
	memcpy(print_ram+print_width,print_ram+2*print_width,browse_form_lines*print_width);
	memset(print_ram+bottom_line,' ',print_width);
}

#IFNOT easy_conf 0 ;

#IF calculator_floats 1 ;
#include "sys55.c"			// floating point functions
#ENDIF ;

#IF calculator_floats 1 ;
int calculator(int type)
{
	struct float result;
	struct float result_to_be_added_later;
	struct float number;
#ELSE ;
int calculator(int type)
{
	int result;
	int result_to_be_added_later;
	int number;
#ENDIF ;

	char operator;
	char buffer[25];
	char key[2];
	int ptr;
	char string[calculator_line_size];
	
	int print;

	if(type==10)
	{
		type=7;
		print=0;
	}
	else
	{
		print=1;
	}

	if(print)
	{
#IF compile_os_menu 1;
		battery_bar(-2);
#ENDIF;	
		if(type==6)
		{
			screen_format=14;
		}
		set_display(0);
		cursor(0);
		
		set_function_keys("-+*/",1);
		cursor_width(0);
		cls();
	
		bottom_line=(browse_form_lines-1)*print_width;
	
		print_string("____ Calculator ____");
	}

	*buffer=0;
#IF calculator_floats 1 ;
	result_to_be_added_later.a=0;
#ELSE ;
	result_to_be_added_later=0;
#ENDIF ;

	if(type==7)
	{
		*string=0;
		ptr=0;
	}

	do
	{
		if(print)
		{
/*
push_variable(get_cursor());
cursor(160);
print_float(result,-1);
putch('f');
really_update_screen();
beep(500,500);
cursor(pop_variable());
*/
			set_update_screen(0);		
			memset(print_ram+bottom_line,' ',print_width);
			if(*buffer)
			{
				cursor(bottom_line+LCDLFWIDTH-1);
				print_string_aligned_right(buffer);
			}
			else
			{
				if(operator=='=')
				{
#IF calculator_floats 1 ;
					ftoa(result,buffer,-1);
					result=(atof(buffer));
#ELSE ;
					itoa(result,buffer,10);
					result=(atoi(buffer));
#ENDIF ;
					cursor(bottom_line+LCDLFWIDTH-1);
					print_string_aligned_right(buffer);
					*buffer=0;
				}
			}
			cursor(bottom_line);
			putch(operator);
	
			set_update_screen(1);
			update_screen();		
		}

		if(type==7)
		{
			do
			{
				if(string[ptr]==0)
				{
					if(print)
					{
						cursor(bottom_line);
					}
					*key=getch();
					if(*key>32)
					{
						if(isdigit(*key))
						{
							ungetch();
							*string=0;
						}
						else
						{
							if( *key > RIGHT || *key < UP )
							{
								ungetch();
								*string=0;
#IF calculator_floats 1 ;
								if(result.a)
								{
									ftoa(result,string,-1);
									result=(atof(string));
								}
#ELSE ;
								if(result)
								{
									itoa(result,string,10);
									result=(atoi(string));
								}
#ENDIF ;
							}
							else
							{
								ptr=strlen(string)-1;
								if(ptr<0)
								{
									ptr=0;
								}
								if( string[ptr]=='=' )
								{
									string[ptr]=0;
								}
							}
						}
		
						if(print)
						{
							scroll_up();
							scroll_up();
						}

						*key=calculator_input(string,calculator_line_size-1);

						if(print)
						{
							set_function_keys("-+*/",1);
						}

						ptr=strlen(string)-1;
						if(ptr<0)
						{
							ptr=0;
						}
						
						if(string[ptr]!='=')
						{	
							strcat(string,"=");
						}
						
						ptr=0;
						
						if(*key!=27)
						{
							*key=0;
						}
						operator='=';			// force a scroll up
					}
				}
				else
				{
					*key=string[ptr];
					ptr++;
					//keyboard_beep();
				}
			}
			while(*key==0);
		}
		else
		{
			*key=getch();
		}

		if(*key==13)
		{
			*key='=';
			if(operator=='=')
			{
				break;
			}
		}
		else
		{
			if(operator=='=')
			{
				if(print)
				{
					scroll_up();
				}
				operator=0;
			}
		}

		if(strchr(buffer,'.'))
		{
			if( isdigit(*key) )
			{
				if( strlen(buffer)<10 )
				{
					strcat(buffer,key);
				}
				continue;
			}
		}
		else
		{


			if( strlen(buffer)<9 )
			{
				if( isdigit(*key) || (*key=='.') )
				{
					strcat(buffer,key);
					continue;
				}
			}

		}

		if(*key==8)
		{
			memset(print_ram+print_width,' ',browse_form_lines*print_width);
			if( *buffer )
			{
				*buffer=0;
			}
			else
			{
#IF calculator_floats 1 ;
				result.a=0;
				result.e=0;
#ELSE ;
				result=0;
#ENDIF ;
			}
			operator=0;
		}
		else
		{
			if( *key=='+' || *key=='-' || *key=='*' || *key=='/' || *key=='=' || *key==27 )
			{

				if(*buffer)
				{
					if(print)
					{
						scroll_up();
					}

#IF calculator_floats 1 ;
					number=atof(buffer);
#ELSE ;
					number=atoi(buffer);
#ENDIF ;
					*buffer=0;

					switch(operator)
					{
						case '-':
#IF calculator_floats 1 ;
								number.a=0-number.a;
#ELSE ;
								number=0-number;
#ENDIF ;
						case '+':
								if( *key=='*' || *key=='/' )
								{
									result_to_be_added_later=result;
									result=number;
								}
								else
								{
#IF calculator_floats 1 ;
									result_to_be_added_later.a=0;
#ELSE ;
									result_to_be_added_later=0;
#ENDIF ;
									result=result+number;
								}
								break;
						case '*':
								result=result*number;
								break;
						case '/':
								result=result/number;
								break;
						default:
								result=number;
/*
push_variable(get_cursor());
cursor(160);
print_float(result,-1);
putch('f');
really_update_screen();
beep(500,600);
cursor(pop_variable());
*/
					}
				}

				if( *key=='+' || *key=='-' || *key=='=' )
				{					
					result=result+result_to_be_added_later;
#IF calculator_floats 1 ;
					result_to_be_added_later.a=0;
#ELSE ;
					result_to_be_added_later=0;
#ENDIF ;
				}
/*
push_variable(get_cursor());
cursor(160);
print_float(result,-1);
putch('f');
really_update_screen();
beep(500,700);
cursor(pop_variable());
*/
				if( type==8 && *key=='=' && ( operator=='=' || operator=='E' ))
				{
					break;
				}
				
				if( !print && *key=='=')
				{
					break;
				}

				operator=*key;
			}
		}
	}
	while( *key!=27 );

	if(operator==27)
	{
		operator=0;
	}
	if(print)
	{
		set_function_keys("",1);
#IF compile_os_menu 1;
		battery_bar(0);
#ENDIF;
	}
	return;
}
#ENDIF ;
#ELSE ;
int calculator(int type)
{
	int result;
	int operator;
	char buffer[25];
}
#ENDIF ;

calculator_input(char *txt,int size)
{
	int c;
	int cc;
	int n,n2;
	int max;
/*
push_variable(get_cursor());
cursor(0);
print_string(txt);
putch('s');
cursor(pop_variable());
*/	
	n=strlen(txt);
	max=n;
	cc=get_cursor();
	
	do
	{
		cursor(cc);
		print_string(txt);
		putch(' ');
		cursor(cc+n);
		really_update_screen();

		c=getch();

		switch(c)
		{
			case 8:
					if(n==max)
					{
						if(n)
						{
							n--;
							txt[n]=0;
							max--;
						}
					}
					else
					{
						if(n)
						{
							strcpy(txt+n-1,txt+n);
							n--;
							max--;
						}
					}
					break;

			case LEFT:
					if(n)
					{
						n--;
					}
					break;

			case RIGHT:
					if(n<max)
					{
						n++;
					}
					break;

			default:
					if(c=='.')
					{
						n2=n;
						while(n2>0)
						{
							n2--;
							if(txt[n2]=='.')
							{
								break;
							}
							if( ( txt[n2]>=42 && txt[n2]<=47 ) || (!n2) )
							{
								if(n<(size-1))
								{
									txt[n]=c;
									n++;
								}
								break;
							}
						}
					}
					else
					{
						if( isdigit(c) || c=='+' || c=='-' || c=='*' || c=='/' )
						{
							if(n<(size-1))
							{
								txt[n]=c;
								n++;
							}
						}
						else
						{
							return(0);
						}
					}
		}
		if(n>max)
		{
			max=n;
		}
		txt[max]=0;
	}
	while(1);
}


