
#IF RadioFunctions 1 ;
set_server_status_line(char status,char *work_base_id)
{
#IF show_server_status_line 1 ;
	char RadioMessageSystem[27];
	int ctponto;
	//char spin[4]={'-','\','|','/'};
	//int energy;

#IF compile_debug_number 1;
debug_number(320);
#ENDIF;	

	if(check_shift_esc())
	{
		reset(0);
	}

#IF compile_debug_number 1;
debug_number(321);
#ENDIF;	
	if((*RadioMessageSystem)==0)
	{
		memset(RadioMessageSystem,' ',27);
		*RadioMessageSystem=254;
		memcpy(RadioMessageSystem+1,"SERVER",6);
		RadioMessageSystem[lcd_width-2]=19;
	}
#IF compile_debug_number 1;
debug_number(322);
#ENDIF;	
	if(status)
	{
		RadioMessageSystem[ctponto+11]=' ';

		if(status=='<')
		{
			ctponto--;
			ctponto=ctponto&7;
			RadioMessageSystem[ctponto+11]='*';
			RadioMessageSystem[lcd_width-4]=status;
		}
		else
		{
			if(status=='>')
			{
				ctponto++;
				ctponto=ctponto&7;
				RadioMessageSystem[ctponto+11]='*';
				RadioMessageSystem[lcd_width-4]=status;
			}
			else
			{
				RadioMessageSystem[lcd_width-3]=status;
			}
		}
/*
		RadioMessageSystem[8]=spin[ctponto%4];
		ctponto++;
		if(energy>FIVESECONDS)
		{
			energy=FIVESECONDS;
		}
		if(energy<0)
		{
			energy=0;
		}
		itoa(energy/ONESECOND,RadioMessageSystem+10,10);
*/
		memcpy(RadioMessageSystem+lcd_width-1,work_base_id+3,2);
#IF compile_debug_number 1;
debug_number(323);
#ENDIF;	
		show_status_line(RadioMessageSystem);
	}
	else
	{
#IF compile_debug_number 1;
debug_number(324);
#ENDIF;	
		show_status_line(0);
	}
#IF compile_debug_number 1;
debug_number(325);
#ENDIF;	
#ENDIF ;
}	

#ENDIF ;

//
// --------------------------------------------------------------
//

#IFNOT software_type RADIOBASE ;

#IF RadioFunctionsVersion 1 ;
#include "sysmessage1.c"						// Old get_message functions
#ENDIF ;

#IF RadioFunctionsVersion 2 ;
#include "sysmessage2.c"						// New get_message functions
#ENDIF ;

#ENDIF ;
//
// --------------------------------------------------------------
//

//
// --------------------------------------------------------------
//

send_msg_without_confirmation(char *BlockPtr,char *destination_id,int MessageSize)
{
int BlockNumber;
int MessageSizeLeft;
int MessageSizeLeftAux=65535;									// Blocos > 64K
int Aux1,Aux2;
char SizeOfMessage;
int SizeOfMessageBlock;
int SIZE_OF_MESSAGE_BLOCK;

	if(MessageSize<65530)
	{
		SIZE_OF_MESSAGE_BLOCK+=4;
	}

	if(MessageSize<SIZE_OF_MESSAGE_BLOCK)
	{
		SizeOfMessageBlock = MessageSize;
	}
	else
	{
		SizeOfMessageBlock = SIZE_OF_MESSAGE_BLOCK;
	}

	if(MessageSize<65530)
	{
		SizeOfMessage=SizeOfMessageBlock+14;
	}
	else
	{
		SizeOfMessage=SizeOfMessageBlock+18;
	}

	message_channel_send
	
	Aux1=0;
	do
	{
		MessageSizeLeft=MessageSize-Aux1;
		BlockIncrNumber++;
		write_message_header
		write_message_block_cc(destination_id,8	wmb_sufix
		write_message_block(&SizeOfMessage,1	wmb_sufix
		write_message_block(terminal_id,8		wmb_sufix
		write_message_block(&BlockNumber,2		wmb_sufix
		write_message_block(&BlockIncrNumber,2	wmb_sufix
		if(MessageSize<65530)
		{
			write_message_block(&MessageSizeLeft,2		wmb_sufix
		}
		else
		{
			write_message_block(&MessageSizeLeftAux,2		wmb_sufix
			write_message_block(&MessageSizeLeft,4		wmb_sufix
		}				
		write_message_block(BlockPtr+Aux1,SizeOfMessageBlock wmb_sufix
		write_message_checksum
		message_channel_delay_after_send
		BlockNumber++;
		Aux1+=SizeOfMessageBlock;
	} while( MessageSize>Aux1);

	message_channel_off
	return(1);
}



//
// --------------------------------------------------------------
//

#IF compile_get_message_debug_info 1;

#IF RadioFunctions 1 ;		

show_radio_debug_info()
{
	int	initialized;
	char	display_buffer[8][40];

	if(inkey()==322)
	{
		initialized=0;
	}
	if(inkey()==321)
	{
		if(!initialized)
		{
			initialized=1;
	
			write_cpu_register32(CPU_DX,display_buffer[0]);
			print_string("Block#:");
			write_cpu_register32(CPU_DX,display_buffer[0]+12);
			print_string("Expec#:");
	
			write_cpu_register32(CPU_DX,display_buffer[1]);
			print_string("BlCoun:");
			write_cpu_register32(CPU_DX,display_buffer[1]+12);
			print_string("BlSize:");
	
			write_cpu_register32(CPU_DX,display_buffer[2]);
			print_string("CoCoun:");

			write_cpu_register32(CPU_DX,display_buffer[3]);
			print_string("ErTime:");

			write_cpu_register32(CPU_DX,display_buffer[4]);
			print_string("ErCoun:");
	
			write_cpu_register32(CPU_DX,display_buffer[5]);
			print_string("Timeou:");
		}
	}
	if(initialized)
	{
		
		write_cpu_register32(CPU_DX,display_buffer[0]+7);
		print_number(BlockNumber_func_get_radio_message);
		write_cpu_register32(CPU_DX,display_buffer[0]+19);
		print_number(ExpectedBlockNumber_func_get_radio_message);
		putch('.');
	
		write_cpu_register32(CPU_DX,display_buffer[1]+7);
		print_number(block_count_func_get_radio_message);
		write_cpu_register32(CPU_DX,display_buffer[1]+19);
		print_number(BlockSize_func_get_radio_message);
		putch('.');
	
		write_cpu_register32(CPU_DX,display_buffer[2]+7);
		print_number(confirmation_counter_func_get_radio_message);
		putch('.');

		write_cpu_register32(CPU_DX,display_buffer[3]+7);
		print_number(errortime_func_get_radio_message);
		putch('.');

		write_cpu_register32(CPU_DX,display_buffer[4]+7);
		print_number(bad_count_func_get_radio_message);
		putch('.');
	
		write_cpu_register32(CPU_DX,display_buffer[5]+7);
		print_number(timeout_func_get_radio_message);
		putch('.');
	
		write_cpu_register32(CPU_SCREENLINE1,display_buffer[0]);
		write_cpu_register32(CPU_SCREENLINE2,display_buffer[1]);
		write_cpu_register32(CPU_SCREENLINE3,display_buffer[2]);
		write_cpu_register32(CPU_SCREENLINE4,display_buffer[3]);
		write_cpu_register32(CPU_SCREENLINE5,display_buffer[4]);
		write_cpu_register32(CPU_SCREENLINE6,display_buffer[5]);
		write_cpu_register32(CPU_SCREENLINE7,display_buffer[6]);
	
		really_update_screen();
		
		while(inkey()>=320)
		{
		}
	}
}


#ENDIF ;

#ENDIF ;



//
// --------------------------------------------------------------
//

