char os_languages[5][10]={
			"Portugues",
			"Espanol  "
			"Deutsch  ",
			"English  ",
			"Francais "
		      };

char os_alpha_modes[4][7]={
			"2+F1=A",
			"1+F1=A"
			"2=A   ",
			"1=A   "
		      };

char no_yes[2][4]=
			{
			"No ",
			"Yes"
			};

#IF software_type AS400 XRML1 XRML2 RADIOBASE ;
int ConnectionType;
char ConnectionTypes[5][6]=
			{
			"Base ",
			"Demo ",
			"Beep ",
			"Base?",
			};
#ENDIF ;

// -------------------------------------------------------------------------

//#IF easy_conf 1;
#IF compile_battery_test 1;
set_discharge(int d)
{
	if(d)
	{
		if(value_func_pic_version<750)
		{
			write_cpu_register(CPU_LHH_VALUE,57088+32);
		}
		else
		{
			write_cpu_register(3984,57088+32);
		}
		set_lcd_light_power(1);
	}
	else
	{
		if(value_func_pic_version<750)
		{
			write_cpu_register(CPU_LHH_VALUE,57088);
		}
		else
		{
			write_cpu_register(3984,57088);
		}
		set_lcd_light_power(0);
	}
}

check_test_bat(int a,int b,int c)
{
	if(!drawing_form)
	{
		if(getch()==13)
		{
			set_discharge(0);
			set_display(0);
			cls();

			if(!internal_shift_key)
			{
				a=get_seconds();
				test_bat_display(0);
				do
				{
					wait_event(4,171);				// 171
					battery_voltage();
					update_battery(171);			// 171
					test_bat_display(0);
					if(c>60*60*10)
					{
						break;
					}
				}
				while(battery_charge<255);
			}
			else
			{
				battery_charge=255;
			}

			cursor(80);
			print_string("Take from charger");
			new_line();
			print_string("and press [Enter]");
			do
			{
				beep(100,100);
				set_discharge(1);
				beep(50,200);
				set_discharge(0);
				if(sensech())
				{
					if(getch()==13)
					{
						break;
					}
				}
			}
			while(1);
			a=get_seconds();
			test_bat_display(40);
			do
			{
				set_discharge(1);
				wait_event(4,171-4);
				set_discharge(0);
				wait_event(4,4);
				battery_voltage();
				update_battery(171);
				test_bat_display(40);
			}
			while(battery_charge>32);
			new_line();
			battery_bar(-1);
			if(c>=300)
			{
				new_line();
				print_string("Battery OK");
				new_line();
				new_line();
				print_string("Wk.Time LightOff:");
				print_number(c/15);
				putch('h');
				print_string("Wk.Time LightOn: ");
				print_number(c/70);
				putch('h');
			}
			else
			{
				print_string("Low battery capacity");
				new_line();
				print_string("Get a replacement");
				new_line();
				print_string("from your dealer or");
				new_line();
				print_string("visit www.x64.com");
			}
			do
			{
				
			}
			while(getch()!=27);
		}
	}
	return(27);
}

test_bat_display(int n)
{
	cursor(n);
	if(n)
	{
		print_string("Discharge for ");
	}
	else
	{
		print_string("Charge for ");
	}
	
	c_func_check_test_bat=get_seconds()-a_func_check_test_bat;
	print_number(c_func_check_test_bat/60);
	print_char('m');

	new_line();
	print_number((battery_charge*100)/255);
	print_string("% ");
	print_number(voltage_func_battery_voltage);
	print_string("mV ");
	print_number(battery_voltage_index);

	new_line();
	if(n)
	{
		print_string("Capacity: ");
		//c_func_check_test_bat = ( c_func_check_test_bat * 120 ) / 3600;
		//c_func_check_test_bat =(c_func_check_test_bat *112)/100;
		c_func_check_test_bat =(c_func_check_test_bat *13)/360;
		print_number(c_func_check_test_bat);
		print_string("mAh   ");

		new_line();
		print_string("Please Wait");
	}
	else
	{
		print_string("Keep on charger");
	}

	battery_bar(1);

	lcd_on2();
	set_lcd_contrast(lcd_contrast-1);
}

#ENDIF ;

// -------------------------------------------------------------------------

my_set_lcd_contrast(int n)
{
	set_lcd_contrast(n-1);
}

#IF compile_os_menu 1;
public int nosay(int n)
{
	form_title_cursor=(read_cpu_register32(CPU_DX)-print_ram);
	system_form[formptr].cursor		=form_title_cursor;
	system_form[formptr].cursorlen	=n;
}
#ENDIF;

save_program2(int a,int b,int c)
{
	if(!drawing_form)
	{
#IF system_type ponto ;
		if(getch()=='6')
		{
			save_program(4096);
			return(26);
		}
		return(DOWN);
#ENDIF ;

#IFNOT system_type ponto ;
		if(getch()==13)
		{
		
			beep(500,500);
		
			beep(100,100);
			setch('1');
			save_program(4096);
			return(26);
		}
		return(DOWN);
#ENDIF ;
	}
}

#IF compile_os_menu 1;
#IF laser_type psc;
test_laser(int a,int b,int c)
{
	int n;
	if(!drawing_form)
	{
		if(getch()==13)
		{
			do
			{
				
				set_external_keyboard_power(1);
				delay(1000000);
				set_external_keyboard_power(0);
				delay(250000);
			}
			while(	inkey()==0);
		}
	}
}
#ENDIF;

#IF software_type xrt100c ;
test_radio_signal(int a,int b,int c)
{
	int canal;
	int n;
	int good;
	int total;

	if(!drawing_form)
	{
		if(getch()==13)
		{
			if(internal_shift_key)
			{
				//xbim_communication_test();
				//multibase_communication_test();
				//xbim_manual_frequency();
				xbim_auto_frequency();
				return(ESCKEY);
			}

			cursor_width(1);
			cursor_height(255);
					
			screen_format=15;	
			set_display(0);
			cls();

			mesa[0]=105;
			canal=105;

			good=1;
			total=2;

			do
			{

				if(canal>168)
				{
					canal=168;
				}

				cursor(0);
				print_string("Canal ");
				print_number(canal);
				putch(' ');

				cursor(40);	
				print_string("----> ");
				print_number(mesa[0]);

				while(!inkey())
				{
					if(canal==mesa[0])
					{
						cursor(120);
						putch(254);
						print_string("Testando...        ");

						cursor(80);
						print_number(100*good/total);
						print_string("% ");

						if(total>50)
						{
							total=total/2;
							good=good/2;
						}

					}
					else
					{
						cursor(120);
						print_string("Configurando antena");
					}

					delay(5000);
					licenca_base=60000+canal;
					radio_channel_off
					funcao='F';
					send_to_pc(0,0);
					if(!inkey())
					{
						total++;
						if(wait_conf())
						{
							beep(10,100);
							radio_channel_off
							if(canal==mesa[0])
							{
								good++;
							}
						}
					}
					delay(5000);
					licenca_base=60000+mesa[0];
					radio_channel_off
					funcao='F';
					send_to_pc(0,0);
					if(!inkey())
					{
						total++;
						if(wait_conf())
						{
							beep(10,100);
							radio_channel_off
							if(canal==mesa[0])
							{
								good++;
							}
							else
							{
								canal=mesa[0];
								beep(500,100);
								good=1;
								total=2;
								break;
							}
						}
					}

				}

				if(canal!=mesa[0])
				{
					if(sensech())
					{
						getch();
					}
				}
				else
				{
					cursor(80);
					print_string("     ");

					while(sensech())
					{
						key=getch();

						if(key=='1')
						{
							set_lcd_light_power(1);
							good=1;
							total=2;
						}

						if(key=='0')
						{
							set_lcd_light_power(0);
							good=1;
							total=2;
						}

						if(key==27)
						{
							cursor_width(0);
							cls();
							print_string("Para usar o canal ");
							print_number(canal);
							new_line();
							print_string("mude a licenca");
							new_line();
							print_string("nas comandas e no PC");
							new_line();
							print_string("para ");
							print_number(60000+canal);
							new_line();
							putch(254);
							print_string("Prima uma tecla");
							getch();
							//reset(0);
							return(ESCKEY);
						}
						
						if(key==RIGHT)
						{
							if(mesa[0]<168)
							{
								mesa[0]++;
							}
						}
						
						if(key==LEFT)
						{
							if(mesa[0]>0)
							{
								mesa[0]--;
							}
						}
	
						cursor(120);
						print_string("Selecao de canal   ");
					
						cursor(46);
						print_string("   ");
						cursor(40);
						print_string("----> ");
						print_number(mesa[0]);
	
						if( key==LEFT || key==RIGHT )
						{
							for(n=0;n<400;n++)
							{
								if(sensech())
								{
									break;
								}
							}
						}
					}
				}
			}
			while(1);
		}
	}

}
#ENDIF ;

#IFNOT software_type xrt100c ;

beep_if_radio()
{
	int good,total;
#IF wireless_network 1 ;
#IF compile_radio_message 1 ;
	good=10;
	total=20;
	strcpy(work_base_id+6," R");
	*(work_base_id+5)=0;
	write_cpu_register32(CPU_COM_TIMEOUT,1);

	set_update_screen(1);
	set_display(0);

	cls();
	print_string("Beep mode");
	new_line();
	print_string(work_base_id);
	putch('-');
	print_string(work_base_id+6);
	beep(100,100);

	do
	{
		cursor(240); 
		print_number(100*good/total);
		print_string("% ");

		if(total>50)
		{
			total=total/2;
			good=good/2;
		}		
		if(test_radio_base(work_base_id,3,1))
		{
			good++;
			total++;
			beep(40,50);
		}
		else
		{
			total++;
			beep(4,500);
		}
		
		
	}
	while(1);
#ENDIF ;
#ENDIF ;
}

test_radio_signal(int a,int b,int c)
{
#IF wireless_network 1 ;
	if(!drawing_form)
	{
		if(getch()==13)
		{
			if(internal_shift_key)
			{
				//xbim_communication_test();
				multibase_communication_test();
			}
			beep_if_radio();
		}
	}
#ENDIF ;
	return(0);
}
#ENDIF ;

#ENDIF ;


#IF tag_type TagIt;
#IF tag_type Rfid125 ;

leit_rfid(int a,int b,int c)
{	
	char buffer[8];
	if(!drawing_form)
	{
		if(getch()==13)
		{
			c=get_cursor();			
			do
			{			
				beep(20,20);
				if(read_rfid_serial(buffer))
				{
					beep(1200,100);
					cursor(c-c%print_width);
					print_number(buffer[0]);
					putch('.');
					print_number(buffer[1]);
					putch('.');
					print_number(buffer[2]);
					putch('.');
					print_number(buffer[3]);
					putch('.');
					print_number(buffer[4]);
					putch('.');
					print_number(buffer[5]);
					putch('.');
					print_number(buffer[6]);
					putch('.');
					print_number(buffer[7]);
					putch(' ');
					getch();
					break;
				}
				if(sensech())
				{
					if(getch()==27)
					{
						break;
					}
				}
			}
			while(1);
			cursor(c);
		}
	}
	return(0);
}

#ENDIF; 
prog_rfid(int a,int b,int c)
{	
	if(!drawing_form)
	{
		if(getch()==13)
		{
			c=get_cursor();			
			numerical(&a,9,0);
			do
			{
				cursor(c);
				print_number(a);
				if(getch()==27)
				{
					break;
				}
				do
				{			
					beep(20,20);
					if(write_rfid_block(1,&a))
					{
						beep(1200,100);
						a++;
						break;
					}
				}
				while(inkey());
			}
			while(1);
			cursor(c);
		}
	}
	return(0);
}

#ENDIF;



// --------------------- Sending Programs  -------------------------------------

#IF system_type rio vertical horizontal ;
#IFNOT software_type RADIOBASE ;
#IF laser_type psc ;
configure_laser(char *ls)
{
	int a;

	if(set_external_keyboard_power(2)==0)
	{
		return(0);			
	}

	if( laser_write_command("@1",50000,10) == 0 )			// Batch programming mode
	{
		beep(100,100);
		set_external_keyboard_power(0);
		return(0);
	}

	a=0;
	while(ls[a*5]!=0)
	{
		if( laser_write_command(ls+a*5,25000,2) == 0 )
		{
			set_external_keyboard_power(0);
			return(0);
		}
		a++;
	}
	
	if( laser_write_command("@2",75000,10) == 0 )			// Batch programming mode OFF
	{
		return(0);
	}
	set_external_keyboard_power(0);
	return(1);
}

configure_laser_intermec(char *ls)
{
	if(set_external_keyboard_power(2)==0)
	{
		return(0);			
	}

	if( !laser_write_command(ls,25000,1) )								// 
	{
		return(0);
	}
	delay(200000);											//	?????
	write_cpu_register32(CPU_COM_TIMEOUT,10000);
	
	while( laser_read_byte() !=-1 )									// Esvaziar buffer e ignora resposta.!!!
	{
		delay(5000);
	}
	beep(50,50);
				
	set_external_keyboard_power(0);
	return(1);
}




#ENDIF ;

#IF compile_radio_message 1 ;
#IF laser_type psc ;
conf_laser(int a,int b,int c)
{
	int Ok;
	if(drawing_form)
	{
		return;
	}
	if(getch()==13)
	{
		memset(temp_string,0,100);
		save_configuration_data();
		Ok=0;
		do
		{
			power_off_countdown();		
			reset_radio_message(work_base_id,"LASER RESET",-1);
			Ok=get_radio_message(temp_string,100,-1);
		}
		while(!Ok);

		configure_laser(temp_string);
		
		return(26);
	}
}
#ENDIF ;

// public 

send_program_radio(int a,int b,int c)
{
	char destination_id[9];

	if(drawing_form)
	{
		return;
	}
	if(getch()==13)
	{
		push_variable(space_in_text);
		space_in_text='_';
		text(destination_id,8,0);
		space_in_text=pop_variable();
		cursor(get_cursor()+9);
		do
		{
			
		}
		while(reset_radio_message(destination_id,"RESET",-1)==0);

		delay(250000);

		if(send_radio_message(4096,destination_id,32768,10))
		{
			print_string("OK  ");
			beep(100,100);
		}
		else
		{
			print_string("FAIL");
			beep(100,50); 
		}
	}
}

recv_program_radio(int a,int b,int c)
{
	int Ok;
	char *aux;
	int *ptr_program;
	if(drawing_form)
	{
		return;
	}
	ptr_program=71920;
	if(getch()==13)
	{
		save_configuration_data();
		Ok=0;
		do
		{
			power_off_countdown();		
			reset_radio_message(work_base_id,"RESET",-1);
			Ok=get_radio_message(ptr_program,65000,-1);
		}
		while(!Ok);
		cls();
		set_display(0);
		print_string("1-RAM/2-EEPROM");
		if(getch()=='2')
		{
			cls();
			cursor_width(0);
			set_display(0);
			print_string("Saving...");
			save_program(ptr_program);
			reset(1);		
		}
		else
		{
			memcpy_reset(4096,ptr_program,*(ptr_program+3));
		}
	}
}

#ENDIF ;
#ENDIF ;
#ENDIF ;
// --------------------------------------------------------------

set_and_print_terminal_id(char *new_id)
{
	set_terminal_id(new_id);
	memcpy(read_cpu_register32(CPU_DX),terminal_id,8);
	update_screen();
}

set_terminal_id_in_cpu(char *new_id)
{
	int n;
	for(n=0;n<8;n++)
	{
		write_cpu_register(n+CPU_RADIO_SYNC1,new_id[n]);
	}
}

public set_terminal_id(char *new_id)
{
#IF RadioFunctionsVersion 2 ;
#IFNOT software_type BATCH RADIOBASE ;
	if(new_id!=terminal_id_in_eeprom)
	{
		memcpy(new_id,work_base_id,3);
		//new_id[3]=' ';
	}
#ENDIF ;
#ENDIF ;

	if(memcmp(terminal_id_in_eeprom,new_id,9))
	{
		write_cpu_register(CPU_EEPROM_LOCK,123);
		//beep(200,200);
		memcpy(terminal_id_in_eeprom,new_id,9);
		write_cpu_register(CPU_EEPROM_LOCK,0);
	}
	memcpy(terminal_id,terminal_id_in_eeprom,9);
	set_terminal_id_in_cpu(new_id);
}

// -------------------------------------------------------------------------
#IFNOT software_type RADIOBASE;
#IF compile_os_menu 1;
#IF easy_conf 1;

os_menu_periodic()
{
//	if( get_seconds() > menu_exit_countdown_start + menu_timeout )
	if(read_cpu_register32_verified(CPU_SECONDS_COUNTER)>menu_exit_countdown_start+menu_timeout)
	{
		setch(27);
	}
	if( was_func_power_off )
	{
		if(power_off_countdown_seconds)
		{
			setch(27);
		}
	}
	get_time();
	disable_update_screen();
	push_variable( get_cursor() );

	//if( ( get_seconds() % 10 ) == 0 )
	//{
	//	cursor( 0 );
	//	draw_bat2(voltage_func_power_off_countdown);
	//}
#IF system_type ponto ;
		cursor(                              8 );
		print_string( time_string );
		cursor( print_width * 1 + 8 );
		print_string( date_string );
		cursor( print_width * 2 + 8 );
		print_string( date_string + 11 );
#ENDIF ;
#IF system_type rio horizontal ;
		cursor( print_width * 3 + 8 );
		print_string( time_string );
		cursor( print_width * 4 + 8 );
		print_string( date_string );
		cursor( print_width * 5 + 8 );
		print_string( date_string + 11 );
#ENDIF ;
#IF system_type vertical ;
		cursor( print_width * 3 + 8 );
		print_string( time_string );
		cursor( print_width * 4 + 8 );
		print_string( date_string );
		cursor( print_width * 5 + 8 );
		print_string( date_string + 11 );
#ENDIF ;
	cursor( pop_variable() );
	enable_update_screen();
	update_screen();
}
#ENDIF;
#ENDIF;
#ENDIF;
// -------------------------------------------------------------------------

#IFNOT system_type ponto ;
#IFNOT software_type XRML1 XRML2 AS400;
#IF compile_os_menu 1;

null(int a,int b,int c)
{
 return(getch());
}
#ENDIF ;
#ENDIF ;
#ENDIF;
// -------------------------------------------------------------------------

#IF compile_os_menu 1 ;
int adjust_bat(int a,int b,int c)
{
	if(!drawing_form)
	{
		c=getch();
#IFNOT system_type vertical ;
		if( c==LEFT && battery_voltage_adjustment )
		{
			battery_voltage_adjustment--;
		}
		if( c==RIGHT && battery_voltage_adjustment<255 )
		{
			battery_voltage_adjustment++;
		}
#ENDIF ;
	}
	print_number(battery_voltage());
	putch(' ');
	return(c);
}
#ENDIF;
// -------------------------------------------------------------------------

#IF system_type rio vertical horizontal ;
set_lcd_light_power2(int n)
{
	set_lcd_light_power(n);
	key_func_browse_form=ESCKEY;
}
#ENDIF ;

// -------------------------------------------------------------------------

#IF compile_os_menu 1 ;
#IF easy_conf 1;

int edit_time(int a,int b,int c)
{
	if(!drawing_form)
	{
		get_time();
		push_variable(text(time_string,"##:##:##",0));
		set_time();
		timetoa(time_seconds,time_string);
		return(pop_variable());
	}
	return(0);
}

// -------------------------------------------------------------------------

int edit_date(int a,int b,int c)
{
	if(!drawing_form)
	{
		get_time();
		push_variable(text(date_string,"##:##:####",0));
		set_time();
		datetoa(date_days,date_string);
		return(pop_variable());
	}
	return(0);
}

#ENDIF ;

// -------------------------------------------------------------------------

set_configuration_defaults_os(int a,int b,int c)
{
	if(!drawing_form)
	{
		if(getch()==13)
		{
			set_configuration_defaults();
			save_configuration_data();
			reset(0);
		}	
	}
}

// --------------------------------------------------------------

check_power_off(int a,int b,int c)
{
	if(!drawing_form)
	{
		if(getch()==13)
		{
		 	power_off();
		}
	}
	return(27);
}

// -------------------------------------------------------------------------

#ENDIF ;

public reset(int a)
{
	char *boot;
	int dont;
	
	if(dont)
	{
		return;
	}

	boot=8388608+13;	

	if( (a&255) > 0 )
	{
		memset(4096+12,0,4);		// Clear RAM program
		memset(4096+13,5,1);		// Clear RAM program
	}
	if( (a&255) > 1 )
	{
		beep(50,50);
		write_cpu_register(CPU_EEPROM_LOCK,123);
#IF software_type RADIOBASE ;
		*boot='7';
#ENDIF ;
		if(a/256)
		{
			*boot=a/256;
		}
#IF system_type ponto ;
		memset(8388608+100,0,16);	// Clear EEPROM program
#ENDIF ;
		write_cpu_register(CPU_EEPROM_LOCK,0);
	}
 	exit();
 	exit();
 	exit();
 	exit();
}

// -------------------------------------------------------------------------

#IF compile_os_menu 1 ;
check_reset(int a,int b,int c)
{
	if(!drawing_form)
	{
#IF system_type rio vertical horizontal ;
		if(getch()==13)
		{
			reset(1);
//		 	if(internal_shift_key)
//	 		{
//	 			reset(2);
//			}
//			else
//			{
//				reset(1);
//			}
	 	}
	 	return(0);
#ENDIF ;
#IF system_type ponto ;
		if(isdigit(sensech()))
		{
			new_numerical(&a,10,0);
			if( a == 6169632 )
			{
				reset(1);
			}
			if( a == 6169633 )
		 	{
		 		reset(2);
			}
		}
		else
		{
			getch();
		}
		return(DOWN);
#ENDIF ;
	}
}
#ENDIF;
// -------------------------------------------------------------------------
#IF compile_os_menu 1 ;
public int check_exit(int a,int b,int c)
{
	int t;
	if(!drawing_form)
	{
		t=getch();
		if( t==13 || t=='=' || t==RIGHT)
		{
			return(26);
		}
	}
	return(0);
}
#ENDIF;
// -------------------------------------------------------------------------

#IF compile_os_menu 1 ;
os_menu(int type)
{
	int x;
/*
	char ostline[2][22]=	{
							254,' ',' ',' ',' ','U','s','e','r',' ','M','e','n','u',' ',' ',' ',' ',253,' ',' ',' ',
							254,' ',' ',' ',' ','S','y','s','t','e','m',' ','M','e','n','u'
						};
*/

	next_update_func_power_off_countdown=0;
	power_off_countdown();

#IF software_type xrt100c ;
	getch_waits_for_radio=0;
#ENDIF ;

// change to own display RAM buffer
#IFNOT software_type RADIOBASE ;

#IF software_type AS400 XRML1 XRML2 ;
	push_variable(ConnectionType);
#ENDIF ;

	for( x=CPU_SCREENLINE1; x<=CPU_SCREENLINE8; x+=4)
	{
		push_variable(read_cpu_register32(x));
	}
#IFNOT system_type ponto ;
	push_variable(fsize_func_set_function_keys);
	push_variable(t1_func_set_function_keys);
#ENDIF ;

	push_variable(get_cursor());

	push_variable(txt_func_text);
	push_variable(max_func_text);
	push_variable(template_func_text);
	push_variable(text_flags_func_text);
	push_variable(x_func_text);
	push_variable(key_func_text);
	push_variable(lastkey_func_text);
	push_variable(n_func_text);
	push_variable(screen_format);

	push_variable(display_address_func_set_display);
	push_variable(print_ram);
	push_variable(print_width);
	push_variable(print_height);
	push_variable(display_ram);
	push_variable(display_width);
	push_variable(display_height);
	push_variable(formptr);
	push_variable(form_display_func_setformptr);
	push_variable(form_func_browse_form);
	push_variable(read_background_function);
	push_variable(read_cpu_register(CPU_BASIC_FLAGS));
#IF pc_keyboard 0 ;
	if(read_cpu_register(CPU_BASIC_FLAGS)&2)
	{
		set_external_keyboard_power(0);
	}
#ENDIF ;
	push_variable(n_func_cursor_height);
	push_variable(n_func_cursor_width);
	push_variable(title_lines);
	push_variable(space_in_text);
	push_variable(init_cursor_pos_func_text);

	cursor_width(0);
	screen_format=0;
	print_ram=4000-40*number_of_os_menu_lines;
	print_width=40;
	print_height=number_of_os_menu_lines;
	cls();	
	display_ram=4000-40*number_of_os_menu_lines;
	display_width=40;
	display_height=number_of_os_menu_lines;
	
#IFNOT system_type ponto ;
	set_function_keys("",1);
#ENDIF ;
	title_lines=0;
	set_display(0);
	if(type<=1)
	{
		if(type)
		{
			battery_bar(-2);
		}
		else
		{
			battery_bar(2);
		}
		type=os_menu_menu();
		if(power_off_countdown_seconds)
		{
			if(light_off_countdown_seconds>power_off_countdown_seconds)
			{
				light_off_countdown_seconds=power_off_countdown_seconds;
			}
		}
		save_configuration_data();
	}
#IFNOT system_type ponto ;
	switch( type )
	{
		case 8:

		case 5:
#IFGREATEROREQUAL system_version 700 ;
		case 6:
		case 7:
#ENDIF ;
#IFNOT easy_conf 0 ;
#IF compile_radio_message 1 ;
#IF radio_type bim ;
				configure_xbim(254,0);
				set_radio_khz(value_func_set_radio_khz);
#ENDIF ;
#ENDIF ;
				calculator(type);
				break;
#ENDIF ;

#IF compile_crash_game 1 ;
#IFGREATEROREQUAL system_version 700 ;
		case 8:
#ELSE ;
		case 6:
#ENDIF ;
				set_display(0);
				crash_game();
				break;
#ENDIF ;

	}
#ENDIF ;

	keylistptr_func_text=0;
	keytimer_func_text=0;

	init_cursor_pos_func_text=pop_variable();
	space_in_text=pop_variable();
	title_lines=pop_variable();
	cursor_width(pop_variable());
	cursor_height(pop_variable());
	write_cpu_register(CPU_BASIC_FLAGS,pop_variable());
	if(read_cpu_register(CPU_BASIC_FLAGS)&2)
	{
		set_external_keyboard_power(1);
	}
	read_background_function=pop_variable();
	form_func_browse_form=pop_variable();
	form_display_func_setformptr=pop_variable();
	formptr=pop_variable();
	display_height=pop_variable();
	display_width=pop_variable();
	display_ram=pop_variable();
	print_height=pop_variable();
	print_width=pop_variable();
	print_ram=pop_variable();
	set_display(pop_variable());

	screen_format=pop_variable();
	n_func_text=pop_variable();
	lastkey_func_text=pop_variable();
	key_func_text=pop_variable();
	x_func_text=pop_variable();
	text_flags_func_text=pop_variable();
	template_func_text=pop_variable();
	max_func_text=pop_variable();
	txt_func_text=pop_variable();
	cursor(pop_variable());
	internal_shift_key=0;
#IFNOT system_type ponto ;
	t1_func_set_function_keys=pop_variable();
	fsize_func_set_function_keys=pop_variable();
	if(t1_func_set_function_keys)
	{
		set_function_keys(t1_func_set_function_keys,fsize_func_set_function_keys);
	}
#ENDIF ;

	for( x=CPU_SCREENLINE8; x>=CPU_SCREENLINE1; x-=4)
	{
		write_cpu_register32(x,pop_variable());
	}

	reset_multitap();

	battery_bar(0);

	really_update_screen();

#IF software_type AS400 XRML1 XRML2 ;
	if(ConnectionType!=pop_variable())
	{
		reset(0);
	}
#ENDIF ;
#ENDIF ;
	call_function(function_before_power_up);
	return(0);
}
#ENDIF ;

// -------------------------------------------------------------------------

#IF software_type AS400 XRML1 XRML2 RADIOBASE ;
change_type_of_connection(int n)
{
	*(work_base_id+5)=0;
	switch(ConnectionType)
	{
		case 0:
			strcpy(work_base_id+6," P");
			break;	
		case 1:	
			strcpy(work_base_id+6," S");
			break;	
		case 2:	
			strcpy(work_base_id+6," B");
			break;
		case 3:	
			strcpy(work_base_id+6," X");
			break;
	}
}
#ENDIF ;

#IF system_type vertical ;
change_upside_down(int n)
{
	set_lcd_contrast(lcd_contrast-1);
}
#ENDIF ;

// -------------------------------------------------------------------------

#IFNOT software_type RADIOBASE ;
public print_inverse(char *st)
{
int n;
int margin;

	if((1<<(get_cursor() / display_width))&screen_format)
	{
		margin=((lcd_width-4)/2)-strlen(st)/2;
	}
	else
	{
		margin=(lcd_width/2)-strlen(st)/2);		
	}

	print_char(254);
	tab(margin+1);
	print_string(st);

}
#ENDIF;

// -------------------------------------------------------------------------
#IF compile_os_menu 1 ;

os_menu_menu()
{
#IFNOT software_type RADIOBASE ;
	if( type_func_os_menu==1 )
	{
#IF debug 0 ;
		print_string("Password ");
		new_text(temp_string,6,-4-8);
#ELSE ;
		strcpy(temp_string,"1111");
#ENDIF ;
		if( (!strcmp(temp_string,"594057")) || (!strcmp( temp_string, "1111" )) )
		{
			type_func_os_menu=2;
		}	
		else
		{
			if(( ctoi(temp_string[0]) == ( ctoi(time_string[0]) + ctoi(date_string[0]) + 6 ) % 10 && ctoi(temp_string[1]) == ( ctoi(time_string[1]) + ctoi(date_string[1]) + 1 ) % 10 && ctoi(temp_string[2]) == ( ctoi(time_string[0]) + ctoi(date_string[3]) + 6 ) % 10 && ctoi(temp_string[3]) == ( ctoi(time_string[1]) + ctoi(date_string[4]) + 9 ) % 10 && strlen(temp_string)==6	) )
			{
				type_func_os_menu=1;
			}
			else
			{
				type_func_os_menu=0;
				if( *os_menu_password && strcmp(temp_string,os_menu_password) )
				{
					return(0);
				}
			}
		}
		cls();
	}
	disable_update_screen();
	formptr=number_of_form_lines-1-number_of_os_menu_lines;
	if( type_func_os_menu )
	{
//
//
#IF system_type ponto ;
		say("Id       ");
		putch(' ');
		memcpy(terminal_id,"PONTO_",6);
//		get(text,terminal_id,8,"::::::##");
		get(text,terminal_id,8,0);
#ENDIF ;

#IF system_type rio vertical horizontal ;
		say("Id       ");
		putch(' ');
//		get(text,terminal_id,8,"@@@@@@##");
		get(text,terminal_id,8,0);
#ENDIF ;

		call_after_get(set_and_print_terminal_id);
		new_line();
//
//
		say("Password ");
		putch(' ');
		get(text,os_menu_password,4,0);
		new_line();
//
//
		if( type_func_os_menu >= 2)
		{
			say("Language ");
			putch(' ');
			get(option,&os_language,os_languages,number_of_os_languages);
			new_line();
//
//
#IF software_type ponto ;
			say("BlockSize");
			putch(' ');
			get(numerical,&update_pc_block_size,3,0);
			new_line();

			say("Fecho Dia");
			putch(' ');
			get(numerical,&configuracoes.fecho_dia,5,0);
			new_line();

			say("Max.Trab.");
			putch(' ');
			get(numerical,&configuracoes.segundos_trabalho_maximo,5,0);
			new_line();

			say("Cart.+BIO");
			putch(' ');
			get(numerical,&configuracoes.bio_card_check,1,0);
			new_line();
#ENDIF ;
		}
//
//
#IF system_type ponto ;
		say("Int.Marc.");
		putch(' ');
		get(numerical,&configuracoes.intervalo_marcacoes,4,0);
		new_line();
//
//
		say("C. Serie ");
		putch(' ');
		get(numerical,&configuracoes.serie_cartao,6,0);
		new_line();
//
//
		say("Porta R1 ");
		putch(' ');
		get(numerical,&configuracoes.abertura_rele1,4,0);
		new_line();
//
//
		say("Porta R2 ");
		putch(' ');
		get(numerical,&configuracoes.abertura_rele2,4,0);
		new_line();
//
//
		say("Auto Ans.");
		putch(' ');
		get(option,&AutoAnswerModem,no_yes,1);
		call_after_get(Auto_answer_modem);
		new_line();
//
//
		say("Ans. Str.");
		putch(' ');
		get(text,dial_string,10,0);
		new_line();
#ENDIF ;

#IF software_type BATCH ;
#IF radio_type gprs ;

		say("IP:");
		putch(' ');
		get(text,dial_ip,16,0);
		new_line();

#ENDIF ;
#IF compile_alarm 1 ;
		say("Connect at:(HHMM):");
		putch(' ');
		get(text,connectat,4,0);
		new_line();
#ENDIF ;



#ENDIF ;




#IF compile_com_message 1 ;
//
//
		say("BaudRate ");
		putch(' ');
		get(option,&index_func_choose_baud_rate,os_baud_rates,10);
		call_after_get(choose_baud_rate);
		new_line();
#ENDIF ;
//
//
		if( type_func_os_menu >= 2)
		{
//
//
			say("PowerDown");
			putch(' ');
			get(numerical,&power_off_countdown_seconds,4,0);
			cursor(get_cursor()+4);
			print_string("s");
			new_line();
//
//
#IF system_type vertical ;
//
//
			say("LaserTime");
			putch(' ');
			get(numerical,&laser_on_time,4,0);
			cursor(get_cursor()+4);
			print_string("ms");
			new_line();
//
//
#ENDIF ;

#IFNOT system_type ponto ;
//
//
			say("Backlight");
			putch(' ');
			get(numerical,&light_off_countdown_seconds,4,0);
			cursor(get_cursor()+4);
			print_string("s");
			new_line();
//
//
			say("ResetTime");
			putch(' ');
			get(numerical,&time_to_reset,5,0);
			cursor(get_cursor()+5);
			print_string("s");
			new_line();
#ENDIF ;
//
//
			say("Bat Low  ");
			putch(' ');
			get(numerical,&unlimited_operation_voltage_limit,4,0);
			cursor(get_cursor()+4);
			print_string("mV");
			new_line();
//
//
			say("Bat Empty");
			putch(' ');
#IF debug 0 ;
			get(numerical_not_less_than,&critical_operation_voltage_limit,4,critical_operation_voltage_limit_limit);
#ELSE ;
			get(numerical,&critical_operation_voltage_limit,4,0);
#ENDIF ;
			cursor(get_cursor()+4);
			print_string("mV");
			new_line();
//
//
			say("Reset    ");
			putch(' ');
			get(check_reset,0,0,0);
			new_line();
//
//
			say("Save Prg");
			get(save_program2,0,0,0);
			new_line();

#IF software_type AS400 XRML1 XRML2;

//
//
			say("Connect. ");
			putch(' ');
			get(option,&ConnectionType,ConnectionTypes,4);
			call_after_get(change_type_of_connection);
			new_line();
#ENDIF ;

#IF system_type vertical ;
			say("UpsideDwn");
			putch(' ');
			get(option,&upside_down,no_yes,1);
			call_after_get(change_upside_down);
			new_line();
			say("Alpha: ");
			putch(' ');
			get(option,&alpha_mode,os_alpha_modes,3);
			new_line();
#ENDIF ;

#IF system_type rio vertical horizontal ;
#IF wireless_network 1 ;
//
//

#IF compile_radio_message 1 ;

			say("Find Base");
			putch(' ');
			get(option,&AutoFindBase,no_yes,1);
			new_line();

			say("Work Base");
			putch(' ');
//			get(text,work_base_id,5,"@@@##");
			get(text,work_base_id,5,0);
			new_line();
//
//
#IF RadioFunctionsVersion 2 ;
			say("Top Bases");
#ELSE ;
			say("Num.Bases");
#ENDIF ;
			putch(' ');
			get(numerical,&NumberOfBases,2,0);
			new_line();
//
//
			say("Send Prog");
			putch(' ');
			get(send_program_radio,0,0,0);
			new_line();
//
//
			say("Recv Prog");
			putch(' ');
			get(recv_program_radio,0,0,0);
			new_line();


#ENDIF ;

#IF tag_type TagIt ;
#IF tag_type Rfid125 ;
			say("Leit.RFID");
			putch(' ');
			get(leit_rfid,0,0,0);
			new_line();
#ENDIF ;
			say("Prog.RFID");
			putch(' ');
			get(prog_rfid,0,0,0);
			new_line();
#ENDIF;


	#IF software_type TELNET ;
//
//
			say("Local Echo ");
			putch(' ');
			get(option,&localecho,no_yes,1);
			new_line();
			
			say("Shift+Right = Right ");
			putch(' ');
			get(option,&shiftright,no_yes,1);
			new_line();
	#ENDIF ;

	#IFNOT software_type RADIOBASE ;
//
//
			say("Test Radio");
			putch(' ');
			get(test_radio_signal,0,0,0);
			new_line();
	#ENDIF ;

	#IF laser_type psc ;
			say("Test Laser");
			putch(' ');
			get(test_laser,0,0,0);
			new_line();
		#IF compile_radio_message 1 ;
			say("Conf Laser");
			putch(' ');
			get(conf_laser,0,0,0);
			new_line();
		#ENDIF ;
	#ENDIF ;




#ENDIF ;
#ENDIF ;

			say("Bat.Volt.");
			putch(' ');
			get(adjust_bat,0,0,0);
			new_line();

#IF compile_debug_trace 1 ;
		say("Debug ");
		putch(' ');
		get(option,&debug_trace_on,no_yes,1);
		new_line();
#ENDIF ;

			say("Set Defaults");
			get(set_configuration_defaults_os,0,0,0);
			new_line();
		}
	}
	else
	{

#IF debug 1 ;
		print_number(absolute_time_seconds_start);
		new_line();
#ENDIF ;

#IF system_type horizontal ;
//
//
		draw_bat();
		new_line();
#ENDIF ;




#IF system_type rio vertical horizontal ;
//
//
		nosay(5);
		print_char(24);
		print_char(25);
		tab(8);		
		get(option,&lcd_light_power,on_off[0],1);
		call_after_get(set_lcd_light_power2);
		cursor(get_cursor()+5);
		new_line();

//
//
		say("CapsLock");
		get(option,&caps_lock,on_off[0],1);
		new_line();

//
//
		nosay(5);
		print_char(20);
		print_char(21);
		tab(8);		
		get(bar,&lcd_contrast,16,8);
		call_after_get(my_set_lcd_contrast);
		new_line();
#ENDIF ;
//
//
#IF easy_conf 1;
		say("Time   ");
		putch(' ');
		get(edit_time,0,0,0);
		new_line();

//
//
		say("Date   ");
		putch(' ');
		get(edit_date,0,0,0);
		new_line();
		new_line();
#ENDIF ;
#IFNOT system_type ponto ;

#IFNOT easy_conf 0 ;
//
//
		say("Calc.1");
		get(check_exit,0,0,0);
		new_line();

#IFGREATEROREQUAL system_version 700 ;
		say("Calc.2");
		get(check_exit,0,0,0);
		new_line();
		say("Calc.3");
		get(check_exit,0,0,0);
		new_line();
#ENDIF ;
#ENDIF ;

#ENDIF ;

#IF gps_type	fastrax ;

		say("Show GPS");
		get(gps_wait_for_fix_menu,0,0,0);
		new_line();
#ENDIF ;

#IF compile_crash_game 1 ;
#IFGREATEROREQUAL system_version 700 ;
//
//
		say("Game");
		get(check_exit,0,0,0);
		new_line();
#ENDIF ;
#ENDIF ;
//
//
#IF easy_conf 1;
		say("Off    ");
		get(check_power_off,0,0,0);
		new_line();
#ENDIF ;
//#IF easy_conf 1;
#IF compile_battery_test 1;
		say("Test Bat");
		get(check_test_bat,0,0,0);
		new_line();
#ENDIF ;
//#ENDIF ;
	}


#IFNOT system_type ponto ;
	say("Db");
	get(check_exit,0,0,0);
	putch(' ');
	write_16c71_byte(20);
	print_number(read_16c71_byte());						// 16c71 resets
	putch('.');
	print_number(reset_counter_func_sysmain);				// 17c44 resets
#IFLESS system_version 710 ;
	if(pic_version()<710)
	{
		putch('.');
		write_16c71_byte(31);
		print_number(read_16c71_byte());					// Bad Commands
	}
#ENDIF ;
#IFNOT software_type RADIOBASE ;
#IF system_type vertical ;
#IFGREATEROREQUAL system_version 700 ;
	putch('.');
	print_number(resets_16c71_func_correct_16c71_reset);		// 16c71 corrections
#IFLESSOREQUAL system_version 710 ;
	putch('.');
	print_number(resets_17c44_func_correct_16c71_reset);		// 16c71 corrections (no 1sec interrupts)
#IF compile_debug_trace 1 ;
	new_line();
	print_string("Dt ");
	print_number(debug_trace_value);
	putch('.');
	print_number(value_func_pic_version);
	putch('.');
	print_number(debug_correction_time);
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
	//write_16c71_byte(255);
	new_line();
#ENDIF ;

	say("Serial ");
	putch(' ');
	get(edit_serial_number,0,0,0);

#IFNOT laser_type none ;
//
//
	if( type_func_os_menu < 2)
	{
		new_line();
		say("Bar.");
//		putch(' ');
		get(new_barcode_text,temp_string,16,0);
	}
#ENDIF ;


#IF tag_type TagIt Rfid125 ;
	if( type_func_os_menu < 2)
	{
		new_line();
		say("Tag.");
		get(new_text,temp_string,10,-1048576-8);
	}
#ENDIF ;



#IF easy_conf 1;
	if(!type_func_os_menu)
	{
		read_background_function=os_menu_periodic;
	}
#ENDIF ;
	really_update_screen_and_enable();
	push_variable(browse_form(system_form+number_of_form_lines-number_of_os_menu_lines-1));
	while(sensech())
	{
		getch();
	}

	return(pop_variable());
#ENDIF ;
}
#ENDIF;

// -------------------------------------------------------------------------

#IFNOT system_type ponto ;
#IFNOT software_type RADIOBASE ;
#IF compile_os_menu 1 ;
public int read()
{
	push_variable(browse_form(system_form));
	formptr=0;
	read_start_field=0;
	read_start_field_title=0;
	read_background_function=0;
	return(pop_variable());
}

#IFNOT software_type xrt100c ;
public noread()
{
	formptr=0;
	read_start_field=0;
	read_start_field_title=0;
	read_background_function=0;
}

#IFNOT software_type AS400 XRML2;

public say_number_string(int a,char *t)
{
	form_title_cursor=(read_cpu_register32(CPU_DX)-print_ram);
	system_form[formptr].cursor		=form_title_cursor;
	print_number(a);
	print_string(t);
	system_form[formptr].cursorlen	=(read_cpu_register32(CPU_DX)-print_ram)-form_title_cursor;
}

public say_string_number(char *t,int a)
{
	form_title_cursor=(read_cpu_register32(CPU_DX)-print_ram);
	system_form[formptr].cursor		=form_title_cursor;
	print_string(t);
	print_number(a);
	system_form[formptr].cursorlen	=(read_cpu_register32(CPU_DX)-print_ram)-form_title_cursor;
}

call_before_get(int f)
{
	if(formptr)
	{
		system_form[formptr-1].function3=f;
	}
}

call_after_select(int f)
{
	if(formptr)
	{
		system_form[formptr-1].function2=0-f;
	}
}

call_before_select(int f)
{
	if(formptr)
	{
		system_form[formptr-1].function3=0-f;
	}
}

/*
set_link(int link)
{
	system_form[formptr-1].link=link;
}
*/

/*
get_link()
{
	return(system_form[formptr].link);
}
*/

#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;
#ENDIF ;


// -------------------------------------------------------------------------

set_configuration_defaults()
{
	power_off_countdown_seconds=power_off_countdown_seconds_value;
	unlimited_operation_voltage_limit=unlimited_operation_voltage_limit_start;
	critical_operation_voltage_limit=critical_operation_voltage_limit_start;
#IF compile_com_message 1 ;
	set_baud_rate(19200);
#ENDIF ;
	os_language=0;
	memset(os_menu_password,0,5);

#IF system_type ponto ;
	battery_voltage_adjustment=66;				// for pic version >= 600 adjustment fixed in 90
#ENDIF ;

#IFNOT system_type ponto ;
	light_off_countdown_seconds=light_off_countdown_seconds_value;
	time_to_reset=time_to_reset_value;
	

	
	strcpy(work_base_id,"BAS00");
	NumberOfBases=1;
	AutoFindBase=0;
#ENDIF ;

#IF system_type vertical ;
	upside_down=0;
	alpha_mode=2;
	laser_on_time=laser_on_time_value;
#ENDIF ;

#IF software_type PONTO ;
#ENDIF ;

#IF software_type ponto ;
#IF software_ponto OR ;
	memset(&configuracoes,0,configuracoes_bytes);
	configuracoes.intervalo_marcacoes=60;
	configuracoes.duracao_mensagens=4;
	configuracoes.fecho_dia=99999999;			// sem fecho de dia
//	configuracoes.segundos_trabalho_maximo=0;
	configuracoes.serie_cartao=8000;
	*dial_ip=0;
	AutoAnswerModem=0;
	update_pc_block_size=30;
#ENDIF ;
#ENDIF ;

#IF software_type BATCH ;
#IF radio_type gprs ;
	*dial_ip=0;
#ENDIF ;
#IF compile_alarm 1 ;
	*connectat=0;
#ENDIF ;
#ENDIF ;



#IF software_type ponto ;
#IFNOT software_ponto OR ;
	memset(&configuracoes,0,configuracoes_bytes);
	configuracoes.intervalo_marcacoes=60;
	configuracoes.duracao_mensagens=4;
	configuracoes.fecho_dia=86100;			// 23:55
//	configuracoes.segundos_trabalho_maximo=0;
	configuracoes.serie_cartao=8000;
	strcpy(dial_string,"&H0 &D0   ");
	update_pc_block_size=30;
	AutoAnswerModem=0;
	update_pc_block_size=30;
#ENDIF ;
#ENDIF ;



	product_code=0;

}

// --------------------------------------------------------------

public save_configuration_data()
{
	int file;
	file=fopen("config","wb");

	fwrite(CONFIG_VERSION,4,1,&file);
#IFNOT system_type ponto ;
	temp_string[0]=91;
	temp_string[1]=7;
	fwrite(temp_string,2,1,&file);
	fwrite(&model_number,4,1,&file);
#ENDIF ;

	fwrite(&power_off_countdown_seconds,2,1,&file);
	fwrite(&unlimited_operation_voltage_limit,2,1,&file);
	fwrite(&critical_operation_voltage_limit,2,1,&file);

#IFNOT software_type TELNET ;
#IFNOT radio_type gprs ;
	fwrite(&index_func_choose_baud_rate,1,1,&file);
	fwrite(&os_language,1,1,&file);
	fwrite(os_menu_password,4,1,&file);
#ENDIF ;
#ENDIF ;

#IFNOT system_type ponto ;
	fwrite(&light_off_countdown_seconds,2,1,&file);
	fwrite(&time_to_reset,4,1,&file);
	fwrite(work_base_id,8,1,&file);
	fwrite(&NumberOfBases,2,1,&file);
	fwrite(&AutoFindBase,1,1,&file);
#ENDIF ;
#IF system_type vertical ;
	fwrite(&upside_down,1,1,&file);
	fwrite(&alpha_mode,1,1,&file);
	fwrite(&laser_on_time,2,1,&file);
#ENDIF ;

	fwrite(&absolute_time_seconds_adjust,4,1,&file);

#IF system_type ponto ;
	fwrite(&configuracoes,configuracoes_bytes,1,&file);
	fwrite(&update_pc_block_size,1,1,&file);
	fwrite(&AutoAnswerModem,1,1,&file);
#ENDIF ;

	fwrite(&battery_voltage_adjustment,1,1,&file);
#IF software_type RADIOBASE ;
	fwrite(&base_send_to_serial_or_radio,1,1,&file);
#ENDIF ;

#IFNOT system_type ponto ;
	fwrite(&product_code,4,1,&file);
#ENDIF;

	fwrite(&new_lcd,1,1,&file);

#IF software_type BATCH ;
#IF radio_type gprs ;
	fwrite(dial_ip,16,1,&file);
#ENDIF ;
#IF compile_alarm 1 ;
	fwrite(connectat,4,1,&file);
#ENDIF ;

#ENDIF ;

	fclose(&file);
}

// --------------------------------------------------------------

load_configuration_data()
{
	int file;

	file=fopen("config","rb");

	fread(temp_string,4,1,&file);

	if(memcmp(temp_string,CONFIG_VERSION,4))
	{
		fclose(&file);
		return(0);
	}
#IFNOT system_type ponto ;
	fread(temp_string,2,1,&file);
	fread(&model_number,4,1,&file);
#ENDIF ;

	fread(&power_off_countdown_seconds,2,1,&file);
	fread(&unlimited_operation_voltage_limit,2,1,&file);
	fread(&critical_operation_voltage_limit,2,1,&file);
	critical_operation_voltage_limit=critical_operation_voltage_limit_start;		// don't allow stupid values to be read ??????
#IF debug 1 ;
//	critical_operation_voltage_limit=-9999999;
#ENDIF ;

#IFNOT software_type TELNET ;
#IFNOT radio_type gprs ;
	fread(&index_func_choose_baud_rate,1,1,&file);
	fread(&os_language,1,1,&file);
	fread(os_menu_password,4,1,&file);
#ENDIF ;
#ENDIF ;

#IFNOT system_type ponto ;
	fread(&light_off_countdown_seconds,2,1,&file);
	fread(&time_to_reset,4,1,&file);
	fread(work_base_id,8,1,&file);
	fread(&NumberOfBases,2,1,&file);
	fread(&AutoFindBase,1,1,&file);
#ENDIF ;

#IF system_type vertical ;
	fread(&upside_down,1,1,&file);
	fread(&alpha_mode,1,1,&file);
	fread(&laser_on_time,2,1,&file);
#ENDIF ;

	fread(&absolute_time_seconds_adjust,4,1,&file);

#IF system_type ponto ;
	fread(&configuracoes,configuracoes_bytes,1,&file);
	fread(&update_pc_block_size,1,1,&file);
	fread(&AutoAnswerModem,1,1,&file);
// #IFNOT software_ponto OR ;
//	fread(dial_string,10,1,&file);
// #ENDIF ;

#ENDIF ;

#IF system_type ponto ;
	fread(&battery_voltage_adjustment,1,1,&file);
#ELSE ;
	fread(&new_lcd,1,1,&file);			// dummy read
#ENDIF;


#IF software_type RADIOBASE ;
	fread(&base_send_to_serial_or_radio,1,1,&file);
#ENDIF;	

#IFNOT system_type ponto ;
	fread(&product_code,4,1,&file);
	if( product_code>799 || product_code<500 )
	{
		product_code=0;
	}
#ENDIF;

	fread(&new_lcd,1,1,&file);

#IF software_type BATCH ;
#IF radio_type gprs ;
	fread(dial_ip,16,1,&file);
#ENDIF ;
#IF compile_alarm 1 ;
	fread(connectat,4,1,&file);
#ENDIF ;

#ENDIF ;

	fclose(&file);
	return(1);
}

// -------------------------------------------------------------------------

#IF compile_crash_game 1 ;

// ----------------------------------------------------------------------------------

#include "track.c"
#include "cara0.c"
#include "cara1.c"

//#include "card0.c"
//#include "card1.c"

char gametrack[2+100*8];
char tracks[4][4]={
				60,96,3,3,
				54,90,9,9,
				48,84,15,15,
				42,78,21,21
			};
#define gapx1 44
#define gapx2 55
#define gapy1 26
#define gapy2 37
char carx,cary;
char carspeed;
char dir;
char dir2;
char track;
char enemy1x,enemy1y;
char enemy1speed;
char enemy1dir;
char enemy1dir2;
char enemy1track;
char enemy1brain;
char enemy2x,enemy2y;
char enemy2speed;
char enemy2dir;
char enemy2dir2;
char enemy2track;
char enemy2brain;
char spriteAx;
char spriteAy;
char spriteAl;
char spriteA0;
int  spriteA1;
int  spriteA2;
char spriteA3;
int  spriteA4;
int  spriteA5;
char spriteA6;
int  spriteA7;
int  spriteA8;
char maskA0;
int  maskA1;
int  maskA2;
char maskA3;
int  maskA4;
int  maskA5;
char maskA6;
int  maskA7;
int  maskA8;
char spriteBx;
char spriteBy;
char spriteBl;
int  spriteB0;
int  spriteB1;
int  spriteB2;
int  spriteB3;
int  spriteB4;
int  spriteB5;
int  maskB0;
int  maskB1;
int  maskB2;
int  maskB3;
int  maskB4;
int  maskB5;
int dotcounter;
int score;
char score2[10];
int lives;
int level;

crash_game()
{
	spriteAx=9;
	spriteAy=3;
	spriteBx=12;
	spriteBy=2;
	do
	{
		cls();
		cursor_width(0);
		cursor(print_width*2+5);
		putch(254);
		print_string(" X64 Crash ");
		putch(253);
		cursor(print_width*4);
		putch(252);
		print_string(" Press Any Key to Play");
		if(getch()==27)
		{
			return;
		}
		dotcounter=-1;
		score=0;
		lives=4;
		level=1;
		do
		{
			cls();
			cursor_width(0);
			cursor(print_width*2+5);
			print_string("Get Ready");
			cursor(print_width*4+6);
			print_string("Level ");
			print_number(level);
			delay(800000);
			play_level();
		}
		while(lives);
		cls();
		cursor_width(0);
		cursor(4);
		putch(254);
		print_string(" Game Over ");
		putch(253);
		cursor(print_width*2+6);
		print_string("Level ");
		print_number(level);
		cursor(print_width*4+2);
		print_string("Level Code ");
		putch('A'+((2*level)%20));
		putch('X'-((7*level)%20));
		putch('B'+((3*level)%20));
		putch('Y'-((9*level)%20));
		cursor(print_width*6+3);
		print_string("Press Any Key");
		getch();
	}
	while(1);
}

play_level()
{
	char key;
	char tick;
	char n;
	if(dotcounter==-1)
	{
		dotcounter=0;
		memcpy(gametrack,track_graphics,2+100*8);
	}

	track=0;
	carx=54;
	dir=0;
	dir2=0;
	cary=tracks[track][dir];

	enemy1track=0;
	enemy1x=30;
	enemy1dir=2;
	enemy1dir2=2;
	enemy1y=tracks[enemy1track][0];

	enemy2track=1;
	enemy2y=20;
	enemy2dir=1;
	enemy2dir2=1;
	enemy2x=tracks[enemy2track][enemy2dir];

	cls();
	enable_Sprites();
	print_sprite_at_character_line(gametrack,0,0,WRITE_SPRITE);

	n=1;
	while(n<lives)
	{
		show_car(cara0_graphics,cara1_graphics,1,21+10*n,32);
		n++;
	}

	tick=0;
	
	show_car(cara0_graphics,cara1_graphics,enemy1dir2,enemy1x,enemy1y);
//	show_car(cara0_graphics,cara1_graphics,enemy2dir2,enemy2x,enemy2y);
	show_car(cara0_graphics,cara1_graphics,dir2,carx,cary);
	
	delay(1000000);
		
	print_sprite_at_character_line(gametrack,0,0,WRITE_SPRITE);

	do
	{

// Draw Sprites /////////////////////////////////////////////////////////////////////////////////////////

		show_car(cara0_graphics,cara1_graphics,enemy1dir2,enemy1x,enemy1y);
//		show_car(cara0_graphics,cara1_graphics,enemy2dir2,enemy2x,enemy2y);
		show_car(cara0_graphics,cara1_graphics,dir2,carx,cary);

		dir2=dir;
		enemy1dir2=enemy1dir;

// Draw Score ///////////////////////////////////////////////////////////////////////////////////////////

/*
		itoa(score,score2,10);
		memcpy(4*print_width+14-strlen(score2),score2,strlen(score2));
		update_screen();
		score++;
*/

// Advance Our Car //////////////////////////////////////////////////////////////////////////////////////

		do
		{
			
			key=inkey();
		}
		while(key==51);

		tick++;
		if(key&64)
		{
			key=key&63;
			beep(1,500);
			carspeed=2;
		}
		else
		{
			if( (tick&3) == 1 )
			{
				beep(1,500);
			}
			carspeed=1;
		}

		switch(dir)
		{
			case 0:
					if( carx >= gapx1 && carx<=gapx2 )
					{
						if(key==11)
						{
							if(cary>tracks[3][dir])
							{
								cary--;
							}
						}
						if(key==17)
						{
							if(cary<tracks[0][dir])
							{
								cary++;
							}
						}
					}
					else
					{
						track=(3*(tracks[0][0]-cary)+4)/(tracks[0][0]-tracks[3][0]);
						if(cary>tracks[track][dir])
						{
							cary--;
						}
						else
						{
							if(cary<tracks[track][dir])
							{
								cary++;
							}
							else
							{
								clear_dots(carx,cary);
								clear_dots(carx+1,cary);
							}
						}
					}
					carx+=carspeed;
					if(carx>=tracks[track][1])
					{
						carx=tracks[track][1];
						dir++;
					}
					break;
					
			case 1:
					if( cary >= gapy1 && cary<=gapy2 )
					{
						if(key==9)
						{
							if(carx>tracks[3][dir])
							{
								carx--;
							}
						}
						if(key==19)
						{
							if(carx<tracks[0][dir])
							{
								carx++;
							}
						}
					}
					else
					{
						track=(3*(tracks[0][1]-carx)+4)/(tracks[0][1]-tracks[3][1]);
						if(carx>tracks[track][dir])
						{
							carx--;
						}
						else
						{
							if(carx<tracks[track][dir])
							{
								carx++;
							}
							else
							{
								clear_dots(carx,cary);
								clear_dots(carx,cary-1);
							}
						}
					}
					cary-=carspeed;
					if(cary<=tracks[track][2])
					{
						cary=tracks[track][2];
						dir++;
					}
					break;
					
			case 2:
					if( carx >= gapx1 && carx<=gapx2 )
					{
						if(key==11)
						{
							if(cary>tracks[0][dir])
							{
								cary--;
							}
						}
						if(key==17)
						{
							if(cary<tracks[3][dir])
							{
								cary++;
							}
						}
					}
					else
					{
						track=(3*(cary-tracks[0][2])+4)/(tracks[3][2]-tracks[0][2]);
						if(cary>tracks[track][dir])
						{
							cary--;
						}
						else
						{
							if(cary<tracks[track][dir])
							{
								cary++;
							}
							else
							{
								clear_dots(carx,cary);
								clear_dots(carx-1,cary);
							}
						}
					}
					carx-=carspeed;
					if(carx<=tracks[track][3])
					{
						carx=tracks[track][3];
						dir++;
					}
					break;
					
			case 3:
					if( cary >= gapy1 && cary<=gapy2 )
					{
						if(key==9)
						{
							if(carx>tracks[0][dir])
							{
								carx--;
							}
						}
						if(key==19)
						{
							if(carx<tracks[3][dir])
							{
								carx++;
							}
						}
					}
					else
					{
						track=(3*(carx-tracks[0][3])+4)/(tracks[3][3]-tracks[0][3]);
						if(carx>tracks[track][dir])
						{
							carx--;
						}
						else
						{
							if(carx<tracks[track][dir])
							{
								carx++;
							}
							else
							{
								clear_dots(carx,cary);
								clear_dots(carx,cary+1);
							}
						}
					}
					cary+=carspeed;
					if(cary>=tracks[track][0])
					{
						cary=tracks[track][0];
						dir=0;
					}
					break;
		}

// Advance Enemy 1 //////////////////////////////////////////////////////////////////////////////////////

		if( enemy1brain>=3 || dotcounter>(96-8*level) )
		{
			enemy1speed=2;
		}
		else
		{
			enemy1speed=1;
		}

		switch(enemy1dir)
		{
			case 2:
					if( enemy1x >= gapx1 && enemy1x <= gapx2 && enemy1brain )
					{
						enemy1track=track;
					}
					else
					{
						enemy1track=(3*(tracks[0][0]-enemy1y)+4)/(tracks[0][0]-tracks[3][0]);
					}
					if(enemy1y>tracks[enemy1track][0])
					{
						enemy1y--;
					}
					if(enemy1y<tracks[enemy1track][0])
					{
						enemy1y++;
					}
				
					enemy1x-=enemy1speed;
					if(enemy1x<=tracks[enemy1track][3])
					{
						enemy1x=tracks[enemy1track][3];
						enemy1dir--;
						enemy1brain=brain();
					}
					break;
			case 1:
					if( enemy1y >= gapy1 && enemy1y <= gapy2 && enemy1brain )
					{
						enemy1track=track;
					}
					else
					{
						enemy1track=(3*(enemy1x-tracks[0][3])+4)/(tracks[3][3]-tracks[0][3]);
					}
					if(enemy1x>tracks[enemy1track][3])
					{
						enemy1x--;
					}
					if(enemy1x<tracks[enemy1track][3])
					{
						enemy1x++;
					}

					enemy1y-=enemy1speed;
					if(enemy1y<=tracks[enemy1track][2])
					{
						enemy1y=tracks[enemy1track][2];
						enemy1dir--;
						enemy1brain=brain();
					}
					break;
			case 0:
					if( enemy1x >= gapx1 && enemy1x <= gapx2 && enemy1brain )
					{
						enemy1track=track;
					}
					else
					{
						enemy1track=(3*(enemy1y-tracks[0][2])+4)/(tracks[3][2]-tracks[0][2]);
					}
					if(enemy1y>tracks[enemy1track][2])
					{
						enemy1y--;
					}
					if(enemy1y<tracks[enemy1track][2])
					{
						enemy1y++;
					}
				
					enemy1x+=enemy1speed;
					if(enemy1x>=tracks[enemy1track][1])
					{
						enemy1x=tracks[enemy1track][1];
						enemy1dir=3;
						enemy1brain=brain();
					}
					break;
			case 3:
					if( enemy1y >= gapy1 && enemy1y <= gapy2 && enemy1brain )
					{
						enemy1track=track;
					}
					else
					{
						enemy1track=(3*(tracks[0][1]-enemy1x)+4)/(tracks[0][1]-tracks[3][1]);
					}
					if(enemy1x>tracks[enemy1track][1])
					{
						enemy1x--;
					}
					if(enemy1x<tracks[enemy1track][1])
					{
						enemy1x++;
					}

					enemy1y+=enemy1speed;
					if(enemy1y>=tracks[enemy1track][0])
					{
						enemy1y=tracks[enemy1track][0];
						enemy1dir--;
						enemy1brain=brain();
					}
					break;

		}

// Advance Enemy 2 //////////////////////////////////////////////////////////////////////////////////////

		enemy2speed=1;

		switch(enemy2dir)
		{
			case 2:
					if( enemy2x >= gapx1 && enemy2x <= gapx2 && enemy2brain )
					{
						enemy2track=track;
					}
					else
					{
						enemy2track=(3*(tracks[0][0]-enemy2y)+4)/(tracks[0][0]-tracks[3][0]);
					}
					if(enemy2y>tracks[enemy2track][0])
					{
						enemy2y--;
					}
					if(enemy2y<tracks[enemy2track][0])
					{
						enemy2y++;
					}
				
					enemy2x-=enemy2speed;
					if(enemy2x<=tracks[enemy2track][3])
					{
						enemy2x=tracks[enemy2track][3];
						enemy2dir--;
						enemy2brain=brain();
					}
					break;
			case 1:
					if( enemy2y >= gapy1 && enemy2y <= gapy2 && enemy2brain )
					{
						enemy2track=track;
					}
					else
					{
						enemy2track=(3*(enemy2x-tracks[0][3])+4)/(tracks[3][3]-tracks[0][3]);
					}
					if(enemy2x>tracks[enemy2track][3])
					{
						enemy2x--;
					}
					if(enemy2x<tracks[enemy2track][3])
					{
						enemy2x++;
					}

					enemy2y-=enemy2speed;
					if(enemy2y<=tracks[enemy2track][2])
					{
						enemy2y=tracks[enemy2track][2];
						enemy2dir--;
						enemy2brain=brain();
					}
					break;
			case 0:
					if( enemy2x >= gapx1 && enemy2x <= gapx2 && enemy2brain )
					{
						enemy2track=track;
					}
					else
					{
						enemy2track=(3*(enemy2y-tracks[0][2])+4)/(tracks[3][2]-tracks[0][2]);
					}
					if(enemy2y>tracks[enemy2track][2])
					{
						enemy2y--;
					}
					if(enemy2y<tracks[enemy2track][2])
					{
						enemy2y++;
					}
				
					enemy2x+=enemy2speed;
					if(enemy2x>=tracks[enemy2track][1])
					{
						enemy2x=tracks[enemy2track][1];
						enemy2dir=3;
						enemy2brain=brain();
					}
					break;
			case 3:
					if( enemy2y >= gapy1 && enemy2y <= gapy2 && enemy2brain )
					{
						enemy2track=track;
					}
					else
					{
						enemy2track=(3*(tracks[0][1]-enemy2x)+4)/(tracks[0][1]-tracks[3][1]);
					}
					if(enemy2x>tracks[enemy2track][1])
					{
						enemy2x--;
					}
					if(enemy2x<tracks[enemy2track][1])
					{
						enemy2x++;
					}

					enemy2y+=enemy2speed;
					if(enemy2y>=tracks[enemy2track][0])
					{
						enemy2y=tracks[enemy2track][0];
						enemy2dir--;
						enemy2brain=brain();
					}
					break;
		}

// Check for a Crash ////////////////////////////////////////////////////////////////////////////////////

		if( ( (carx-enemy1x) < 5 ) && ( (carx-enemy1x) > -5 ) )
		{
			if( ( (cary-enemy1y) < 5 ) && ( (cary-enemy1y) > -5 ) )
			{
				beep(10,10000);
				lives--;
				break;
			}
		}
		
		if( dotcounter >= 96 )
		{
			beep(100,300);
			dotcounter=-1;
			level++;
			break;
		}

	}
	while(1);
}

show_car(char *car0,char* car1,char dir,int x,int y)
{
	char line;
	int  *video_ram_int;
	char *video_ram_char;

	if(dir&1)
	{
		x=x-4;
		y=y-8;
		if(y>=0)
		{
			line=y/8;
			memcpy(&spriteA0, car1+3    +(y%8)*27, 27);
			memcpy(&maskA0,   car1+3+234+(y%8)*27, 27);
		}
		else
		{
			line=0;
			memcpy(&spriteA0, car1+3    +(y+8)*27+9], 27);
			memcpy(&maskA0  , car1+3+234+(y+8)*27+9], 27);
		}

		video_ram_char=gametrack+3+x+100*line;
		video_ram_int =video_ram_char+1;

		spriteA0 = video_ram_char[0];
		spriteA1 = spriteA1 | ( video_ram_int[0]  & maskA1 );
		spriteA2 = spriteA2 | ( video_ram_int[1]  & maskA2 );

		spriteA3 = video_ram_char[100];
		spriteA4 = spriteA4 | ( video_ram_int[25] & maskA4 );
		spriteA5 = spriteA5 | ( video_ram_int[26] & maskA5 );

		spriteA6 = video_ram_char[200];
		spriteA7 = spriteA7 | ( video_ram_int[50] & maskA7 );
		spriteA8 = spriteA8 | ( video_ram_int[51] & maskA8 );

		print_sprite_at_character_line(&spriteAx,x,line,WRITE_SPRITE);

	}
	else
	{
		if(dir)
		{
			x=x-4;
			y=y-4;
			if(y>=0)
			{
				line=y/8;
				memcpy(&spriteB0, car0+3+3        +(y%8)*24, 24);
				memcpy(&maskB0  , car0+3+3+24*8+24+(y%8)*24, 24);
			}
			else
			{
				line=0;
				memcpy(&spriteB0, car0+3+3        +(y+8)*24+12, 24);
				memcpy(&maskB0  , car0+3+3+24*8+24+(y+8)*24+12, 24);
			}
		}
		else
		{
			x=x-7;
			y=y-4;
			if(y>=0)
			{
				line=y/8;
				memcpy(&spriteB0, car0+3        +(y%8)*24, 24);
				memcpy(&maskB0  , car0+3+24*8+24+(y%8)*24, 24);
			}
			else
			{
				line=0;
				memcpy(&spriteB0, car0+3        +(y+8)*24+12, 24);
				memcpy(&maskB0  , car0+3+24*8+24+(y+8)*24+12, 24);
			}
		}
		video_ram_int =gametrack+3+x+100*line;

		spriteB0 = spriteB0 | ( video_ram_int[0]  & maskB0 );
		spriteB1 = spriteB1 | ( video_ram_int[1]  & maskB1 );
		spriteB2 = spriteB2 | ( video_ram_int[2]  & maskB2 );
		spriteB3 = spriteB3 | ( video_ram_int[25] & maskB3 );
		spriteB4 = spriteB4 | ( video_ram_int[26] & maskB4 );
		spriteB5 = spriteB5 | ( video_ram_int[27] & maskB5 );

		print_sprite_at_character_line(&spriteBx,x,line,WRITE_SPRITE);

	}
}

brain()
{
	return( rnd(level+1) );
}

clear_dots(int carx,int cary)
{
	char dots[8]={254,253,251,247,239,223,191,127};
	char dot;
	char *ptr;
	char a;
	
	dot=dots[cary%8];
	ptr=3+carx+100*(cary/8);
	a=gametrack[ptr] & dot;

	if( gametrack[ptr] != a  )
	{
		beep(2,50);
		gametrack[ptr] = a ;
		dotcounter++;
	}
}

#ENDIF ;

/*
	for(n=0;n<256;n++)
	{
		buffer[n]=n;
		beep(100,100);
		print_number[n];
	}
*/

